/* ====================================================================
   Copyright (C) 2010-2011 Krzysztof Marecki


   This file is part of the NReports project
	
   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.


   For additional information,email dotnetreports@gmail.com
*/
using System;
using System.Configuration;

namespace NReports.RDL
{
	public static class PdfFiles
	{
		const string PdfWriterConfigName = "NReports.PdfWriter";
		
		public static IPdfWriter CreateWriter ()
		{	
			IPdfWriter writer = null;
			string typename = ConfigurationManager.AppSettings [PdfWriterConfigName];
			if(!string.IsNullOrEmpty (typename)) {
				Type type = Type.GetType (typename, true);
				writer = (IPdfWriter) Activator.CreateInstance (type);
			} else {
				writer = new PdfWriter ();
			}
			return writer;
		}
	}
}

